/* -*- Mode: C; tab-width: 8; indent-tabs-mode: t; c-basic-offset: 4 -*- */

/* $Id$ */

/*
 * This file is automatically generated.
 * Please modify `call-vector.pl' and `call-vector.h.in'.
 */

/* Copyright (C) 1998-99 Martin Baulig
   This file is part of LibGTop 1.0.

   Contributed by Martin Baulig <martin@home-of-linux.org>, April 1998.

   LibGTop is free software; you can redistribute it and/or modify it
   under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License,
   or (at your option) any later version.

   LibGTop is distributed in the hope that it will be useful, but WITHOUT
   ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or
   FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
   for more details.

   You should have received a copy of the GNU General Public License
   along with LibGTop; see the file COPYING. If not, write to the
   Free Software Foundation, Inc., 59 Temple Place - Suite 330,
   Boston, MA 02111-1307, USA.
*/

#ifndef __GLIBTOP_CALL_VECTOR_H__
#define __GLIBTOP_CALL_VECTOR_H__

#include <glibtop.h>
#include <glibtop/union.h>

BEGIN_LIBGTOP_DECLS

typedef struct _glibtop_call_vector	glibtop_call_vector;

struct _glibtop_call_vector
{
	int (*cpu) (glibtop *, glibtop_backend *, glibtop_cpu *);
	int (*mem) (glibtop *, glibtop_backend *, glibtop_mem *);
	int (*swap) (glibtop *, glibtop_backend *, glibtop_swap *);
	int (*uptime) (glibtop *, glibtop_backend *, glibtop_uptime *);
	int (*loadavg) (glibtop *, glibtop_backend *, glibtop_loadavg *);
	int (*shm_limits) (glibtop *, glibtop_backend *, glibtop_shm_limits *);
	int (*msg_limits) (glibtop *, glibtop_backend *, glibtop_msg_limits *);
	int (*sem_limits) (glibtop *, glibtop_backend *, glibtop_sem_limits *);
	unsigned * (*proclist) (glibtop *, glibtop_backend *, glibtop_array *, int64_t, int64_t);
	int (*proc_state) (glibtop *, glibtop_backend *, glibtop_proc_state *, pid_t);
	int (*proc_uid) (glibtop *, glibtop_backend *, glibtop_proc_uid *, pid_t);
	int (*proc_mem) (glibtop *, glibtop_backend *, glibtop_proc_mem *, pid_t);
	int (*proc_time) (glibtop *, glibtop_backend *, glibtop_proc_time *, pid_t);
	int (*proc_signal) (glibtop *, glibtop_backend *, glibtop_proc_signal *, pid_t);
	int (*proc_kernel) (glibtop *, glibtop_backend *, glibtop_proc_kernel *, pid_t);
	int (*proc_segment) (glibtop *, glibtop_backend *, glibtop_proc_segment *, pid_t);
	char ** (*proc_args) (glibtop *, glibtop_backend *, glibtop_array *, pid_t);
	glibtop_map_entry * (*proc_map) (glibtop *, glibtop_backend *, glibtop_array *, pid_t);
	glibtop_mountentry * (*mountlist) (glibtop *, glibtop_backend *, glibtop_array *, int);
	int (*fsusage) (glibtop *, glibtop_backend *, glibtop_fsusage *, const char *);
	glibtop_interface * (*interface_names) (glibtop *, glibtop_backend *, glibtop_array *, u_int64_t, u_int64_t, u_int64_t, u_int64_t);
	glibtop_ifaddr * (*netinfo) (glibtop *, glibtop_backend *, glibtop_array *, glibtop_netinfo *, const char *, u_int64_t);
	int (*netload) (glibtop *, glibtop_backend *, glibtop_netload *, const char *, unsigned, unsigned);
	int (*ppp) (glibtop *, glibtop_backend *, glibtop_ppp *, unsigned short, unsigned short);
};

END_LIBGTOP_DECLS

#endif
